/**Rappresento la mano in un singolo frame
@author Agostini, Carlon, De Cassai
@version 0.01 versione scheletrica abbozzata WIP 04GIU07
@version 0.02 versione abbozzata, i punti non alineati son diposti in array WIP 06GIU07
@version 0.03 aggiunti alcuni metodi WIP 07GIU07
@version 0.04 rotazione e posizione resa stabile WIP 08GIU07
@version 0.06 iniziara la trattazione del clic WIP 09GIU07
*/

public class Hand{


protected Point2D[] points; //qui metto i punti che non son allineati
protected int rotation;//angolo di rotazione
protected Point2D offset;
protected int distance;

protected int nset=0;

private Point2D[] punti_allineati=new Point2D[2];

private boolean knowOrientation=false;//imposto a vero se e solo se son sicuro dell'angolo. se falso angolo +-k*PI
private static final double COLLINEAR_TOLL=5;//errore massimo perke 3 punti siano considerato collineari

/**Costruttore di default
*/
	public Hand(){this((Point2D[])null,0,0,(Point2D)null);}
	
/**Costruttore leggermente pi utile
	@param Point2D[] array delle poizioni delle dita
	@param Point2D posizione del medio
	@param Point2D posizione del centro della mano
*/
	public Hand(Point2D[] p,int d, int r, Point2D o){
		points=p;
		distance=d;	
		rotation=r;
		offset=o;
		if (p!=null)
			nset=p.length;
		else nset=0;
	}
	
/**Costruttore decisamente utile, ma per cui bisogna lavorarci...luchino.....
	@param ImageStreaming l'immagine da cui ricaviamo i dati*/
	public Hand(ImageStreaming is){
		//dobbiamo metter l'errore!!! se ho meno di 3 set luminosi
		
		Point2D [] p=PointsAnalyzer.createSets(is);
		nset=p.length;
		

		if (nset<3)
			offset=null;
				
		else{	
			int[] idx=new int[3];//l'indice dei 3 punti collineari
			
			idx=Point2D.collineare(p);//me li calcolo i collineari
			
			
			if(Point2D.collineare (p[idx[0]],p[idx[1]],p[idx[2]])>COLLINEAR_TOLL)
				offset=null;
			else{
				
				knowOrientation=true;//ho dei punti con cui decidere l'angolo	
			//		System.out.print("Collineari: ");
	/*		for (int i=0;i<3;i++)
			{System.out.print(p[idx[i]]);}
			System.out.println();//*/
			//cerco i due punti pi distanti
				double max_dist=0;
				double tmp;
				int t_idx=0;
				for (int i=0;i<p.length;i++){
									
					tmp=Point2D.EuclideanDistance(p[idx[(i+1)%idx.length]],p[idx[(i-1+idx.length)%idx.length]]);
					if (tmp>max_dist){
						max_dist=tmp;
						t_idx=i;					
					}	
				}//in t_idx ho l'indice del punto medio
				offset=p[idx[t_idx]];
				punti_allineati[0]=p[idx[(t_idx+1)%idx.length]];
				punti_allineati[1]=p[idx[(t_idx-1+idx.length)%idx.length]];
			
			//calcolo la stima della distanza
				distance=PointsAnalyzer.sensorDistance(p[idx[(t_idx+1)%idx.length]],p[idx[(t_idx-1+idx.length)%idx.length]]);

				tmp=Point2D.EuclideanDistance(p[idx[(t_idx+1)%idx.length]],p[idx[(t_idx)%nset]]);
				//riciclo la variabile max_dist
				max_dist=Point2D.EuclideanDistance(p[idx[(t_idx-1+idx.length)%idx.length]],p[idx[(t_idx)%idx.length]]);
				
				
				
				rotation=PointsAnalyzer.rotation(p[idx[(t_idx-1+idx.length)%idx.length]],p[idx[(t_idx+1)%idx.length]]);	

				t_idx=0;//riciclo la variabile, ora indica in che cella andr scritto	
				points=new Point2D[p.length-idx.length];//preparo array per le dita, non so quante sono
				for (int i=0;i<idx.length;i++)
					p[idx[i]]=null; //annullo in p gli elementi collineari
				for (int i=0;i<p.length;i++){
					if (p[i]!=null){
						points[t_idx]=p[i];
						t_idx++;
					}		
				}//adesso ho inizializzato anke i punti finali
				
				int cont=0;
				
			//	System.out.println("cerco angoli con dita");
				if (knowOrientation){//se so dove son le dita faccio un controllo
					for (int i=0;i<points.length;i++){
						if(PointsAnalyzer.rotation(offset,points[i])-rotation>=0)
							cont++;
						else cont--;	

					}
					//se ho pi segnali sotto ke sopra inverti orientamento
					if (cont>0) rotation=(rotation+180)%360;
				}
		//		System.out.println("Rotazione: "+rotation);
			//LUCHINO.....................IO TI INVOCO
			}		
	}}
	
	
	
	
	
/**Rendo la rotazione. Non controllo se quantizzato o meno...
	@return int l'angolo di rotazione*/
	public int getRotation(){return rotation;}
	
/**Rendo la stima della distanza.
	@return int la distanza*/
	public int getDistance(){return distance;}
	
/**Rendo la posizione assoluta dei punti non allineati.
	@return Point2D[] le coordinate dei punti*/
	public Point2D[] getExternalPoints(){return points;}

	
/**Rendo la posizione assoluta del centro
	@return Point2D le coordinate del centroide*/
	public Point2D getCentralPosition(){return offset;}
	
/**Rendo il numero di punti non allineati
	@param int il numero di punti non collineari*/
	public int numberExternal (){return points.length;}
	
/**Rendo se il frame ha significato, ovvero se  utile
	@return boolean true se il frame ha significato*/
	public boolean isUseful(){return (offset!=null);}//se il punto mediano  nullo significa ke non ho informazione..

/**Ritorno il numero di segnali
	@return int il numero di set*/
	public int getNumberSet(){return nset;}
	
/**Ritorno i due punti estremi collineari
	@return Point2D[] i punti allineati che non fungono da baricentro*/
	public Point2D[] getCollinearPoints(){return punti_allineati;}

}