/**Rappresento le variazioni della mano nel tempo.
@author Agostini, Carlon, De Cassai
@version 0.01 versione scheletrica abbozzata WIP 06GIU07
@version 0.02 iniziato interfacciamento con la classe hand WIP 08GIU07

da ricordarsi di implementar la conquista del mondo

se qualcuno si chiedesse il nome della classe basta guardare sul dizionario
*/

public class HandHandler{

private final int ANGLE_TO_CLICK=25;//ANGOLO PER IL CLIC

private final int DEGREE_STEP=10;//il passo di quantizzazione
private final int MAX_NO_SIGNAL=10;//pongo un limite ai frame senza significato con cui chiudo l'applicazione
private final int NO_SIGNAL_RESET=30;//a questo valore considero il frame memorizzato senza significato
private static final int ANGLE_OFFSET=40;//l'angolo di rotazione di base del guanto
private static final int DISTANCE_TO_R_CLIC=180;


private static final int SCREEN_W=1024;
private static final int SCREEN_H=768;
private static final int CAM_W=320;
private static final int CAM_H=240;



private boolean acquired=false;//se le impostazioni della mano son settate e quindi valide

private int no_signal_frame=0;//numero frame senza segnale
private int n_frame=0;//numero di frame. da verificare se serve
public boolean l_clic=false;
public boolean double_l_clic=false;
public boolean r_clic=false;
private Point2D[] ext_p;//le posizioni attuali delle dita


private double index_area;
private double medium_area;
public Point2D coordinate_schermo=new Point2D(0,0);//le coordinate sullo schermo
private Point2D barycentre;
private int rotation=0;
private int distance;
private int real_angle;//angolo non quantizato
private boolean init=false;

private double angolo_div;


//private Hand storedHand;//qui memorizzo alcune informazioni...


/**Costruttore di default*/
	public HandHandler(){}
	
/**Costruttore
	@param Hand l'oggetto mano da cui estrapolare i dati*/
	public HandHandler(Hand h){
		if (h.isUseful()&&h.numberExternal()==2){  //la parte commentata va messa quando si hanno 5 led
			init=true;
			acquired=true;//ho inizializzato lo stato
			barycentre=h.getCentralPosition();
			real_angle=h.getRotation()-ANGLE_OFFSET;
			normalAngle(real_angle+ANGLE_OFFSET);
			distance=h.getDistance();
			ext_p=h.getExternalPoints();

			System.out.println("i punti son "+ext_p[0]+" "+ext_p[1]+" l'indice  "+whosIndex(ext_p,rotation+ANGLE_OFFSET));
			
			
			
			for (int i=0;i<2;i++){
				
				
				
	//			distanza[i]=PointsAnalyzer.pointRectDistance(ext_p[i],coeff[0],coeff[1]);
	//			distanza[i]*=distance;
			}//ora ho in standard le posizioni normalizzate senza rotazioni e traslazioni
			
		
			
		}
		
		
	
	}
	
/**Con questo metodo si cerca di capire se c son stati clic*/
	public boolean[] clic(){
		boolean[] c=new boolean[2];
		c[0]=true; c[1]=true;
		
		
		
		

		return c;
	}	

/**Metodo che aggiorna i valori tramite l'acquisizione di nuovi dati
	@param Hand h la mano con cui aggiornare i dati se sensati*/
	public void refresh(Hand h){
		if (!h.isUseful()){
			no_signal_frame++;
			System.out.println("nn trovo nulla da "+no_signal_frame);
			if (no_signal_frame==NO_SIGNAL_RESET){
				acquired=false;System.out.println("Ho resettato le posizioni");
			}
		}else{
			no_signal_frame=0;//aggiorno il contatore di frame inutili
			ext_p=h.getExternalPoints();
			
			
			



//considero valida solo I 2 TERZI CENTRALI DELLA CAM
			l_clic=false;
			r_clic=false;
			double_l_clic=false;
			



			


			distance=h.getDistance();
			
			real_angle=h.getRotation()-ANGLE_OFFSET;
			
			int oldRotation=rotation;
			normalAngle(real_angle+ANGLE_OFFSET);
			
			
			if ((Math.abs(oldRotation)<ANGLE_TO_CLICK)&&(Math.abs(rotation)>ANGLE_TO_CLICK)){
				//HO UN EVENTO CLIC sinistro
				System.out.println("Clic sinistro");
				if (oldRotation<0)
					l_clic=true;
				else
					double_l_clic=true;
			}
			if (distance<DISTANCE_TO_R_CLIC)
				r_clic=true;
	
		
		System.out.println("Condizione accesso: "+!((l_clic)||(double_l_clic)||(r_clic)));
		//	double normalX=(SCREEN_W*barycentre.getX())/(CAM_W);
		//	double normalY=(SCREEN_H*barycentre.getY())/(CAM_H);
			if (!((l_clic)||(double_l_clic)||(r_clic))){//se nn sto cliccando tengo ferma la posizione
				barycentre=h.getCentralPosition();
				double tmp_x=barycentre.getX();
				double tmp_y=barycentre.getY();
				double normalX=(1.5*SCREEN_W*(.5+((2*tmp_x-CAM_W)/(2*CAM_W))));
				double normalY=(1.5*SCREEN_H*(.5+((2*tmp_y-CAM_H)/(2*CAM_H))));			
				if (normalX>SCREEN_W)normalX=SCREEN_W;
				if (normalY<0)normalY=0;
				if (normalY>SCREEN_H)normalY=SCREEN_H;
				if (normalX<0)normalX=0;
				coordinate_schermo=new Point2D((int)(SCREEN_W-normalX),(int)(SCREEN_H-normalY));
				System.out.println("Coordinate Schermo: "+coordinate_schermo);
			}
						
			
			if (!acquired){
				acquired=true;
			//uso il frame come punto di partenza
			}
			

		}
			
	}

	
	
	public int getDistance(){return distance;}
	public int getRotation(){return rotation;}
	public Point2D getCentralPosition(){	return barycentre;	}
	
/**Normalizzo l'angolo di rotazione quantizzandolo e portandolo nell'intervallo[-180..180]
	@param int l'angolo da normalizzare*/
	private void normalAngle(int r){
		r=(r+(DEGREE_STEP/2))/DEGREE_STEP;
		r=(r-(180/DEGREE_STEP));
		r*=DEGREE_STEP;
		r-=ANGLE_OFFSET;	//ora effettuo un controllo
		if (Math.abs(rotation-r)<3*DEGREE_STEP){
			rotation=r;
		}else{//vuol dire ke ho sbagliato la lettura
			rotation=(180+r)%180;
		}
		
	
	}
	
/**Ritorno vero se l'oggetto  stato inizializzato*/
	public boolean initializated(){return init;}

/**Metodo per sapere se ho superato il limite di frame inutili contigui
	@return boolean Ritorno se ho raggiunto o superato il massimo di frame senza informazione*/
	public boolean haveiToStop(){return !(no_signal_frame<MAX_NO_SIGNAL);}
	
	
	
	
/**Rendo l'indice che identifica l'indice, visto come il punto pi a destra nell'immagine
	@param Point2D[] l'array di punti (di solito 2)
	@return int l'indice dell'array
	*/
	private int whosIndex(Point2D[] p, double angle){
		double tmp=0;
		int idx=-1;
		System.out.println("Ruoto di "+(angle-ANGLE_OFFSET));
		
		for (int i=0;i<p.length;i++){
			System.out.print("il punto "+p[i]);
			p[i].rotate((int)angle-ANGLE_OFFSET);//giro il guanto	
			System.out.println(" diventa "+p[i]);
			if (p[i].getX()>tmp){
				tmp=p[i].getX();
				idx=i;
			}
		}//for
		
		return idx;	
	}
}//class