import javax.imageio.ImageIO;				//per aprire l'immagine
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.io.File;
import java.lang.NullPointerException;

import javax.swing.ImageIcon;				//per visualizzare l'immagine
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Color;
import java.awt.Image;						//per convertire l'immagine da BufferedImage a Image
import java.awt.Toolkit;


public class ImageStreaming
{	private BufferedImage immagine;
		
	public ImageStreaming(String path)
	{	File fileImmagine = null;			//solo per inizializzare la variabile
		try
		{	fileImmagine = new File(path); }
		catch (NullPointerException e)
		{	System.out.println("Path errata!"); }
		try
		{	immagine = ImageIO.read(fileImmagine); }
		catch (IOException e)
		{	System.out.println("Path errata!"); }
	}
	
	public ImageStreaming(BufferedImage i)
	{	immagine = i;
	}
	
	public void show()
	{	Image immagineTemp = this.toImage();
		
		JFrame frame = null;
		frame = new JFrame();
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		JLabel iconLabel = new JLabel(new ImageIcon(immagineTemp));
		JPanel panel = new JPanel();
		panel.add(iconLabel);
		frame.setContentPane(panel);
		frame.pack();
		frame.show();
	}
	
	public void show(int x,int y,int c)
	{	Graphics2D g2D = (Graphics2D)immagine.getGraphics();
		if (c == 0)
			g2D.setColor(Color.black);
		else g2D.setColor(Color.white);	
		g2D.fillOval(x,y,10,10);
		this.show();
	}
	
	public Image toImage()
	{	return Toolkit.getDefaultToolkit().createImage(immagine.getSource());
   }
	
	public BufferedImage toBufferedImage()
	{	return immagine;
	}
	
	public int[] toArrayRGB()
	{	int w = immagine.getWidth();
		int h = immagine.getHeight();
		int[] temp = new int[w*h];
		immagine.getRGB(0,0,w,h,temp,0,w);
		return temp;
	}
	
	public int getRGB(int x,int y)
	{	return immagine.getRGB(x,y);
	}
	
	public void setRGB(int x, int y, int rgb)
	{	immagine.setRGB(x,y,rgb);
	}
	
	public void setRGB(int[] rgbArray)
	{	immagine.setRGB(0,0,immagine.getWidth(),immagine.getHeight(),rgbArray,0,getWidth()) ;
	}
	
	public void toFile(String nome)//salva l'immagine in un file, di codifica bmp
	{	try
		{	javax.imageio.ImageIO.write(immagine, "bmp", new java.io.File(nome+".bmp"));
		}
		catch(IOException e)
		{	System.out.println("Errore nella creazione del file");
		}
	}
	
	public ImageStreaming clone()
	{	BufferedImage clone = new BufferedImage(immagine.getWidth(),immagine.getHeight(),immagine.getType()); 
      clone.getGraphics().drawImage(immagine, 0, 0, null, null); 
		return new ImageStreaming(clone);
 	}
	
	
	public int getType()
	{	return immagine.getType();
	}
	
	public int getWidth()
	{	return immagine.getWidth();
	}
	
	public int getHeight()
	{	return immagine.getHeight();
	}
	

	public boolean isBlack(int x, int y){
		return (getRGB(x,y)!=-1);
	}
	
	
	
	public ImageStreaming CleanGrey(){
		ImageStreaming immy=clone();
		for (int i=0;i<immagine.getHeight();i++){
			for (int j=0;j<immagine.getWidth();j++){
				if (immagine.getRGB(j,i)!=-1)//se non  bianco impostalo a nero
					immy.setRGB(j,i,0);		//questo filtra magari si puo' migliorare
			}
		}
		return immy;
	}
	//l'elemento i,j ha true se  bianco
		public boolean[][] CleanGreyBoolean(){
		boolean[][] b=new boolean[immagine.getWidth()][immagine.getHeight()]; 
		for (int i=0;i<immagine.getHeight();i++){
			for (int j=0;j<immagine.getWidth();j++){
				if (immagine.getRGB(j,i)!=-1)//se non  bianco impostalo a nero
					b[j][i]=false;
				else b[j][i]=true;		//questo filtro magari si puo' migliorare
			}
		}
		return b;
	}
	
	   public int contRGB(int rgb){
		int cont=0;
      for (int j=1;j<immagine.getWidth();j++)
			for (int i=1;i<immagine.getHeight();i++)
				if (immagine.getRGB(j,i)==rgb)cont++;
					
       return(cont);
	}
}