 /**Classe per l'analisi delle posizioni dei punti della mano nell'immagine
@author Luca Agostini
@version 0.01 Versione Abbozzata WIP 03GIU07
*/

public class Matrix
{

	/**Controlla che tutte le righe della matrice di interi abbiano la stessa dimensione.
	   @param int[][] Matrice da controllare.
	   @return TRUE se  rettangolare, FALSE se di forma irregolare.*/
	public static boolean isRectangular (int[][] m)
	{	if (m==null || m[0]==null) return false;
		int length = m[0].length;
		for (int i=1; i<m.length; i++)
			if (m[i]==null || m[i].length != length)
					return false;
		return true;
	}//isMatrix


	/**Controlla che tutte le righe della matrice di double abbiano la stessa dimensione.
	   @param int[][] Matrice da controllare.
	   @return TRUE se  rettangolare, FALSE se di forma irregolare.*/
	public static boolean isRectangular (double[][] m)
	{	if (m==null || m[0]==null) return false;
		int length = m[0].length;
		for (int i=1; i<m.length; i++)
			if (m[i]==null || m[i].length != length)
					return false;
		return true;
	}//isMatrix


	/**Moltiplicazione di matrici di interi tramite il metodo di Gauss.
	   @param int[][] Prima matrice.
	   @param int[][] Seconda matrice.*/
	public static int [][] mul (int[][] a, int[][] b)
	{	if (!isRectangular(a) || !isRectangular(b) || a[0].length != b.length) return null;
		int [][] ris = new int [a.length][b[0].length];
		
		for (int i=0; i<ris.length; i++)
			for (int j=0; j<ris[0].length; j++)
				for (int r=0; r<a[0].length; r++)
					ris [i][j] += a[i][r] * b[r][j];
		return ris;
	}//mulMatrix


	/**Moltiplicazione di matrici di double tramite il metodo di Gauss.
	   @param int[][] Prima matrice.
	   @param int[][] Seconda matrice.*/
	public static double [][] mul (double[][] a, double[][] b)
	{	if (!isRectangular(a) || !isRectangular(b) || a[0].length != b.length) return null;
		double [][] ris = new double [a.length][b[0].length];
		
		for (int i=0; i<ris.length; i++)
			for (int j=0; j<ris[0].length; j++)
				for (int r=0; r<a[0].length; r++)
					ris [i][j] += a[i][r] * b[r][j];
		return ris;
	}//mulMatrix




	/**Stampa una matrice a schermo.
	   @param int[][] Matrice da stampare.*/
	public static String toString (int[][] m)
	{	if (!isRectangular(m)) return null;
		String s = "";
		for (int i=0; i<m.length; i++)
		{	for (int j=0; j<m[0].length; j++)
				s += m[i][j] + "\t";
			s += "\n";
		}//for
		return s;
	}//toString


}//Matrix
