/**Classe di descrizione di un insieme
@author Luca Agostini
@version 0.01 Versione Abbozzata WIP 02GIU07
*/

class Set
{	
	//Array degli oggetti memorizzati
	private Object set [];
	//Numero di elementi memorizzati
	private int num;


	/**Costruttore.
	   @param int Il numero di insiemi massimo da considerare*/
	Set (int k)
	{	this ();
		if (k>0) set = new Object [k];
	}//SetPoint2D


	/**Costruttore.
	   @param int Il numero di insiemi massimo da considerare*/
	Set ()
	{	set = new Object [2];
		num = 0;
	}//SetPoint2D


	Object get (int el)
	{	if (el>=0 && el<size())
			return set[el];
		return null;
	}//get



	/**Indica se l'insieme  vuoto.
	   @return True se vuoto, altrimenti false*/
	public boolean isEmpty ()
	{	return num==0;
	}//isEmpty


	/**Indica la quantit di elementi all'interno dell'insieme.
	   @return Il numeor di elementi memorizzati*/
	public int size ()
	{	return num;
	}//size


	/**Aggiunge un elemento all'insieme dei punti*/
	public void add (Object p)
	{	if (num==set.length-1) realloc();
		set[num++]=p;
	}//add


	/**Ingrandisce uno degli insiemi.
	   @param int Indica quale degli insiemi si ingrandisce.*/
	private void realloc ()
	{	//Memorizzo la grandezza dell'array
		int len = set.length;
		//Memorizzo in tmp il set da ingrandire
		Object []tmp = set;
		//Ingrandisco la memoria del set
		set = new Object [len*2];
		//Copio gli elementi gi memorizzati nella nuova locazione
		for (int i=0; i<tmp.length; i++) set[i] = tmp [i];
	}//realloc


	/**Metodo per la stampa dell'insieme*/
	public String toString ()
	{	String s = "";
		for (int i=0; i<size(); i++)
			s += get(i) + " ";
		return s += "\n";
	}//toString


}//SetPoint2D
