/**Classe di descrizione di un insieme di punti
@author Luca Agostini
@version 0.01 Versione Abbozzata WIP 02GIU07
*/

class SetPoint2D extends Set
{
	private final int SOGLIA_DIST = 3;

	/**Controlla l'adiacenza tra un punto p e ogni altro punto all'interno dell'insieme.
	   @param Point2D Il punto con cui si controlla l'adiacenza.
	   @return TRUE se c' un'adiacenza, FALSE altrimenti.*/
	private boolean checkDistance(Point2D p)
	{	for (int i=0; i<size(); i++)
		{	if (Point2D.distance(p,(Point2D)get(i))<=SOGLIA_DIST)
				return true;
		}//for
		return false;
	}//checkDistance


	/**Costruisce l'insieme dei punti adiacenti.
	   @param Point2D[] L'array di punti dal quale creare l'insieme.
	   @param int Limite superiore degli elementi dell'array da confrontare.
	   @return Il numero di elementi non scelti nell'array di punti dato.*/
	public int buildSet (Point2D [] points, int length)
	{	//Confronto fino alla fine dell'array o fino al limite imposto da length
		int max=Math.min (points.length,length);
		int i=0;
		
		//Aggiungo all'insieme il primo elemento
		this.add(points[0]);
		points[0]=points[max-1];
		max--;
		while (i<max)
		{	//Se un punto  distante al pi un pixel, allora lo aggiungo all'insieme
			if (this.checkDistance((Point2D)points[i]))
			{	this.add(points[i]);
				points[i]=points[max-1];
				max--;
				i=0;
				continue;
			}//if
			i++;
		}//while
		return max;
	}//buildSet



	/**Calcola il centro dei punti dell'insieme.
	   @return Il centro dei punti dell'insieme.*/
	public Point2D getCentre()
	{	int x=0,y=0;
		for (int i=0; i<size(); i++)
		{	Point2D point = (Point2D)get(i);
			x+=point.getX();
			y+=point.getY();
		}//for
		x/=size();
		y/=size();
		return new Point2D(x,y);
	}//getCentre

}//SetPoint2D
